
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"

#include "tiffio.h"

#define INTEL

static void Error(msg)
char        *msg;
	{
		fputs(msg,stderr);
		fputc('\n',stderr);
		exit(1);
	}
	
/*----------------------------------------------------------------------*/

void	StoreTiffFile(path,Nx,Ny,BPS,hell,desc)
char	*path,*desc;
short	Nx,Ny,BPS;
unsigned short *hell;
{
	TIFF	*image;
	long	i, j, k, l;

	image = TIFFOpen(path, "wl");

	TIFFSetField(image, TIFFTAG_IMAGEWIDTH, Nx);
	TIFFSetField(image, TIFFTAG_IMAGELENGTH, Ny);
	TIFFSetField(image, TIFFTAG_BITSPERSAMPLE, BPS);
	TIFFSetField(image, TIFFTAG_COMPRESSION, COMPRESSION_NONE);
	TIFFSetField(image, TIFFTAG_PHOTOMETRIC, PHOTOMETRIC_MINISBLACK);
	TIFFSetField(image, TIFFTAG_SAMPLESPERPIXEL, 1);
	TIFFSetField(image, TIFFTAG_ROWSPERSTRIP, 1);
//	TIFFSetField(image, TIFFTAG_ORIENTATION, ORIENTATION_TOPLEFT);// ȂĂ悢
//	TIFFSetField(image, TIFFTAG_FILLORDER, FILLORDER_MSB2LSB);
//	TIFFSetField(image, TIFFTAG_STRIPBYTECOUNTS,h.width*sizeof(short));
//	TIFFSetField(image, TIFFTAG_DATATYPE, TIFF_SHORT);  // ȂĂ悢
	TIFFSetField(image, TIFFTAG_PLANARCONFIG, PLANARCONFIG_CONTIG);
	TIFFSetField(image, TIFFTAG_IMAGEDESCRIPTION, desc);
	TIFFSetField(image, TIFFTAG_ARTIST, "SP-uCT");

	for(i = 0; i < Ny; ++i)
		TIFFWriteRawStrip(image, i, hell+i*Nx, Nx*sizeof(short));

	TIFFClose(image);
}


/*----------------------------------------------------------------------*/


int	main(argc,argv)
int	argc;
char	**argv;
{
	int		Nx,Ny,BPS,dBPS;
	long	vv,hh,j, lval, hval, i, l_inv;
	double	dd, dval;
	Cell	**cell;
	char	*desc;
	char	fout[50];
	char	fname[50];
	FILE	*f;

	unsigned short	*hell;

	if (argc<2) {
	    fputs("usage : stifhwx inputfile \n",stderr);
	    exit(1);
	}
	dBPS=16;

// open parameter file
	if((f = fopen(argv[1],"r")) == NULL){
		printf("cannot open %s \n", argv[1]);
		return(-10);
	}

	i=0;
	while( fscanf(f, "%s", fname) != EOF){
//		printf("%s\n", fname);
		ReadImageFile(fname,&Nx,&Ny,&BPS,&cell,&desc);
		if (i==0){
			// initialize cell and bell
			hell = (unsigned short *)malloc(Nx*Ny*sizeof(short));
		}

		j=0;
		for (vv=0; vv<Ny; vv++){
			for (hh=0; hh<Nx; hh++){
				*(hell+j) = (unsigned short)(cell[vv][hh]);
				j=j+1;
			}
		}
		
		sprintf(fout, ".\\hex\\%s", fname);
//		printf("%s\n",fout);
		
		if(desc==NULL){
		    if ((desc=(char *)malloc(13))==NULL)
			printf("comment memory allocation error.\n");
			sprintf(desc,"convert image");
		}

		StoreTiffFile(fout,Nx,Ny,dBPS,hell,desc);
		
		printf("%s -> %s \n", fname, fout);
		i=i+1;
	}

	return 0;
}
